﻿cd "C:\Axcess\File_Substitute"
$Global:filelist =Get-Content -Path "$(Get-Location)\file-list.txt"
$Global:SaaSpath="C:\Program Files (x86)\WK\ProSystem fx Suite\Smart Client\SaaS"


function ReplaceDlls(){
   $checkprocess = Get-Process "CCH.CommonUIFramework.Shell" -ea SilentlyContinue
    if ($checkprocess){
        $checkprocess.CloseMainWindow()
        Sleep 5
        if(!$checkprocess.HasExited){
            $checkprocess | Stop-Process -Force
            Write-Host "Process exited successfully"
        }else{
            Write-Host "Process did not exit successfully"
            return
        }


    }
     foreach ($fileitem in $Global:filelist) {
        $srcFile = "C:\Axcess\File_Substitute\Source\$($fileitem)"
        $targetFile = "$($Global:SaaSpath)\$($fileitem)"

        if( [System.IO.File]::Exists($targetFile) -eq $false ) {
            [System.IO.File]::Copy($srcFile, $targetFile, $true)
        }
      }
}

Write-Host "Updating CCH Axcess"
$srcFolder = "C:\Program Files (x86)\WK\ProSystem fx Suite\Smart Client\SaaS"
$targerFolder = "C:\Axcess\File_Substitute\Backup"
$parentFolder = [System.IO.Path]::GetDirectoryName( $targerFolder );
$list = ('Microsoft.Bcl.AsyncInterfaces.dll',
'Microsoft.Extensions.Configuration.Abstractions.dll',
'Microsoft.Extensions.Configuration.Binder.dll',
'Microsoft.Extensions.Configuration.dll',
'Microsoft.Extensions.DependencyInjection.Abstractions.dll',
'Microsoft.Extensions.DependencyInjection.dll',
'Microsoft.Extensions.Logging.Abstractions.dll',
'Microsoft.Extensions.Logging.Configuration.dll',
'Microsoft.Extensions.Logging.dll',
'Microsoft.Extensions.Options.ConfigurationExtensions.dll',
'Microsoft.Extensions.Options.dll',
'Microsoft.Extensions.Primitives.dll',
'System.Buffers.dll',
'System.Numerics.Vectors.dll',
'System.Threading.Tasks.Extensions.dll',
'System.ValueTuple.dll',
'System.Memory.dll',
'System.Runtime.CompilerServices.Unsafe.dll',
'WK.Telemetry.WcfMessageInspector.Client.dll',
'OpenTelemetry.dll',
'OpenTelemetry.Api.dll',
'System.Collections.Immutable.dll',
'System.Diagnostics.DiagnosticSource.dll');

if( [System.IO.Directory]::Exists( $parentFolder ) -ne $true )
{
    [System.IO.Directory]::CreateDirectory( $parentFolder );
}

if( [System.IO.Directory]::Exists( $targerFolder ) -ne $true )
{
    [System.IO.Directory]::CreateDirectory( $targerFolder );
}

foreach($item in $list)
{
    $srcFile = [System.IO.Path]::Combine($srcFolder, $item);
    $targetFile = [System.IO.Path]::Combine($targerFolder, $item);
    if ( [System.IO.File]::Exists( $srcFile ) )
    {
        [System.IO.File]::Copy( $srcFile, $targetFile, $true )
    }
}

    if(Test-Path $Global:SaaSpath){
        ReplaceDlls
    }

Write-Host "Update success"

